
# from flet import(
# UserControl,Control,Alignment,FilePickerResultEvent,Page,app,
# Row,TextField, Text, Slider,BorderSide, colors,Border, border,
# BoxShadow,Offset,ShadowBlurStyle,LinearGradient,GradientTileMode,
# Container,TextButton,Column,Tab,Tabs,AlertDialog,MainAxisAlignment,
# DataTable, TextThemeStyle,IconButton, icons, DataColumn,
# DataCell,TextAlign,FontWeight, Dropdown, dropdown, TextStyle,
# DataRow, ElevatedButton
# )
from flet import*
import flet as ft
from threading import Thread
from time import time, sleep
from pandas import DataFrame
from pandas import to_datetime
from datetime import datetime
from re import findall
from pyperclip import copy
import json
from pyautogui import position
import keyboard as kb
import logging
from datetime import datetime



def escrever_json(self, data, filename):
    if not filename.endswith('.json'):
        filename += '.json'
    with open(filename, 'w') as f:
        json.dump(data, f, indent=4)

def ler_json(self, filename, default=None):
    if not filename.endswith('.json'):
        filename += '.json'
    try:
        with open(filename, 'r') as f:
            return json.load(f)
    except (FileNotFoundError, json.JSONDecodeError):
        try:
            self.escrever_json(default, filename)
        except:
            pass
        return default or {}


import logging
from datetime import datetime


class Logs():
    def __init__(self, arquivo_txt):


        # Custom logging format to handle Brazilian date format
        class CustomFormatter(logging.Formatter):
            def formatTime(self, record, datefmt=None):
                # Format the date to DD-MM-YYYY HH:MM:SS
                return datetime.fromtimestamp(record.created).strftime('%d-%m-%Y %H:%M:%S')

        # Configurar o logger
        file_handler = logging.FileHandler(arquivo_txt)
        file_handler.setLevel(logging.ERROR)
        file_formatter = CustomFormatter('%(asctime)s - %(levelname)s - %(message)s')
        file_handler.setFormatter(file_formatter)

        console_handler = logging.StreamHandler()
        console_handler.setLevel(logging.ERROR)
        console_formatter = CustomFormatter('%(asctime)s - %(levelname)s - %(message)s')
        console_handler.setFormatter(console_formatter)

        logger = logging.getLogger()
        logger.setLevel(logging.ERROR)
        logger.addHandler(file_handler)
        logger.addHandler(console_handler)
    
        return logger.error("Ocorreu um erro", exc_info=True)


class Gestos(ft.Stack):
    def __init__(self,nome_json):
        super().__init__()
        self.nome_json = nome_json
        def colun(x=1):
            return {"xs":x,"sm": x, "md": x, "lg": x, "xl": x,"xxl": x}
        self.expand=True
        self._movimento = True
        # self.positions = positions
        self.controls = []

    @property
    def movimento(self):
        return self._movimento
    
    @movimento.setter
    def movimento(self, movimento:bool):
        if isinstance(movimento, bool):            
            self._movimento = movimento
            if self._movimento:
                for i in self.controls:
                    i.on_vertical_drag_update = self.on_pan_update
                self.update()
        else:
            print(f'o valor dado para "movimento" não é booleano')


    def Add_control(self,nome, control ):
        if isinstance(self.nome_json, dict):
            self.arquiv = self.nome_json
        elif isinstance(self.nome_json, str):
            self.arquiv = self.ler_json(self.nome_json, default={nome:{'left':0,'top':0}})
            try: 
                self.arquiv[nome] == 5
                
            except KeyError:
                self.arquiv[nome] = {'left':0,'top':0}
            self.escrever_json(self.arquiv,self.nome_json)


        if self._movimento:
            self.controls.append(
                ft.GestureDetector(
                    mouse_cursor=ft.MouseCursor.MOVE,
                    on_vertical_drag_update=self.on_pan_update if self._movimento else None,
                    
                    left=self.arquiv[nome]['left'],
                    top=self.arquiv[nome]['top'],               
                    content= control ,
                    data = nome
                )
            )
        else:
            try:
                control.left=self.arquiv[nome]['left']
                control.top=self.arquiv[nome]['top']              
                control.data = nome
                self.controls.append(control)
            except:
                self.controls.append(
                    ft.Column(
                        controls = [control],
                        left=self.arquiv[nome]['left'],
                        top=self.arquiv[nome]['top'],
                        data = nome   
                        )
                )
                
        


    def on_pan_update(self, e: ft.DragUpdateEvent):
        e.control.top = max(0, e.control.top + e.delta_y)
        e.control.left = max(0, e.control.left + e.delta_x)
        self.arquiv[e.control.data]['left'] = e.control.left
        self.arquiv[e.control.data]['top'] = e.control.top
        if isinstance(self.nome_json, str):
            self.escrever_json(self.arquiv,self.nome_json)
        e.control.update()
        

    def escrever_json(self, data, filename):
        if not filename.endswith('.json'):
            filename += '.json'
        with open(filename, 'w') as f:
            json.dump(data, f, indent=4)

    def ler_json(self, filename, default=None):
        if not filename.endswith('.json'):
            filename += '.json'
        try:
            with open(filename, 'r') as f:
                return json.load(f)
        except (FileNotFoundError, json.JSONDecodeError):
            try:
                self.escrever_json(default, filename)
            except:
                pass
            return default or {}


class Tabe(ft.Tabs):
    def __init__(self,  funcao = None, *controls):
        super().__init__()
        self.selected_index=1
        self.animation_duration=3
        self.expand=1
        self.controls = list(controls)
        self.funcao = funcao
        self.on_change = self.func
        if isinstance(self.controls, list) and len(self.controls) >0:
            for i in self.controls: 
                if len(i) == 2:                
                    self.tabs.append(ft.Tab(icon=i[0],content=i[1] ))
                else:
                    self.tabs.append(ft.Tab(text=i[0],content=i[1] ))


    def Add(self, icone, janela):
        self.tabs.append(ft.Tab(icon=icone,content=janela ))
        try:
            self.update()
        except:
             pass

    def func(self,e):
        if self.funcao != None:
            self.funcao(e)
        # pass


     

class Atalhos:
    def __init__(self,page):
        super().__init__()
        self.page = page
        self.arq_abrev = self.Ler_json('abreviacoes.json')
    def Aplicar_atalhos(self):
        kb.add_hotkey('capslock',self. Clic)

        for i,j in self.arq_abrev.items():
            kb.add_abbreviation(i, j)

        # kb.add_abbreviation('f.', 'Fórum de Salgado')
        # kb.add_abbreviation('F.', 'Fórum de Salgado')
        # kb.add_abbreviation('e.', 'Expedi Mandados')
        # kb.add_abbreviation('E.', 'Expedi Mandados')    
        kb.wait('shift+esc')
        kb.remove_all_hotkeys()               
    def Clic(self):
        # Obtém o estado atual do Caps Lock
        caps_lock_state = kb.is_pressed('caps lock')

        # Inverte o estado do Caps Lock
        kb.press_and_release('caps lock')

        # Restaura o estado anterior do Caps Lock
        if caps_lock_state:
            kb.press('caps lock')
        else:
            kb.release('caps lock')

        # Clique do mouse (pode ser ajustado conforme necessário)
        pyautogui.click()

    def Ler_json(self, nomedoarquivo):  # retorna um dicionário
        if nomedoarquivo[-4:] != 'json':
            nomedoarquivo = nomedoarquivo+'.json'
        with open(nomedoarquivo, 'r') as f2:
            try:
                a = json.load(f2)
                return a
            except json.JSONDecodeError as e:
                print(f"Erro ao decodificar JSON: {e}")
                return {}

class Resize:
    def __init__(self,page):
        self.page = page
        self.page.on_resize = self.page_resize
        self.pw = ft.Text(bottom=10, right=10, theme_style=ft.TextThemeStyle.TITLE_MEDIUM )
        self.page.overlay.append(self.pw)   

    def page_resize(self, e):
        self.pw.value = f"{self.page.window_width}*{self.page.window_height} px"
        self.pw.update()
class Teclas:
    def __init__(self,page):
        self.page = page
        self.page.on_keyboard_event = self.Teclas
        self.tecla = None
        while self.tecla != 'enter':
            sleep(0.3)
    
    def Teclas(self, e: ft.KeyboardEvent):
        match e.key:
            case 'Enter':
                self.tecla = 'enter'
            # case 'Escape':
            #     self.tecla = 'esc'
class AtalhosTexto(ft.Column):
    def __init__(self,page):
        super().__init__()
        self.page = page
        self.abreviacao = ft.IconButton(icon=ft.icons.APP_SHORTCUT, 
                tooltip='criar atalho', on_click=self.CriarAbreviacao)
        # self.page.add(self.abreviacao)
        self.Editar = ft.IconButton(icon=ft.icons.SETTINGS, 
                tooltip='Editar atalhs', on_click=self.Editar_atalhos)


        self.scroll=ft.ScrollMode.ADAPTIVE
        self.height = 510
        self.auto_scroll=True
        self.info = f'''
ctrl+alt+a: cria uma abreviação
alt: botão do meio do mouse
capslock: clic
eee: enviar mandados
eeee: enviar mandados simplificado
config: configurar enviar mandado
ctrl+ç: baixar mandado
ctrl+/: baixar mandados
ctrl+]: Transferir mandado
cbcb: configurar transferir mandado
add: Adicionar novo contato à agenda do iphone (usando mouse)
addconfig: Configurar Adicionar novo contato à agenda do iphone (usando mouse)
inci: Iniciar navegador (selenium)
verific: Verificar contatos (selenium)
rasp: Raspar mandados
slenv: Enviar mandados(selenium)
slenvt: Enviar mandados(selenium) - apenas a mensagem
tttt: atualizar planilha dos mandados
testoff: Para enviar os mandados para os devidos contatos (selenium) (padrão)
teston: Para enviar os mandados para leanio moraes  (selenium)
tabel: para exibir a tela dos mandado a serem enviados
pppp: preparar PDFs dos mandados para impressão
'''
        


        self.Infos()

    def Aplicar_atalhos(self):
        kb.add_hotkey('capslock',self. Clic)

        # for i,j in ap.arq_abrev.items():
        #     self.kb.add_abbreviation(i, j)

        # # self.kb.add_abbreviation('f.', 'Fórum de Salgado')
        # # self.kb.add_abbreviation('F.', 'Fórum de Salgado')
        # # self.kb.add_abbreviation('e.', 'Expedi Mandados')
        # # self.kb.add_abbreviation('E.', 'Expedi Mandados')    
        kb.wait('shift+esc')
        kb.remove_all_hotkeys()          

    def Infos(self):
        self.dic_info = {
            'Atalho': [i.split(":")[0] for i in self.info.split('\n')[1:-1]],
            'Função': [i.split(":")[1] for i in self.info.split('\n')[1:-1]]
        }
        a = ''
        for i in self.info.split('\n')[1:]:
            try:
                a += f'{i.split(":")[0]}:  {i.split(":")[1]}\n\n'
            except:
                pass
        self.arq_abrev = Ler_json('abreviacoes.json')
        for i, j in self.arq_abrev.items():
            a += f'{i}: {j} \n\n'

            # print(i,j)

        self.tabelaInfo = Text(a, width=800, selectable=True, size = 18)

        self.controls = [self.tabelaInfo,ft.Row([self.abreviacao, self.Editar])]

    def Add_nova_abreviacao_lista(self, texto):
        self.saidad.visible = True
        self.saidad.controls.append(Text(texto, selectable=True))
        self.update()

    def Save_abreviation(self, e,nome_json):
        abrev = self.abrev.value
        subst = self.subs.value
        if abrev != '' and subst != '':
            # print(f'{abrev} >> {subst}')
            kb.add_abbreviation(abrev, subst)
            self.arq_abrev = Ler_json(nome_json)
            self.arq_abrev[abrev] = subst
            Escrever_json(self.arq_abrev, nome_json)
            self.a.print_in_dialog(f'Nova abreviação adicionada ({abrev} >> {subst})')
            # self.Add_nova_abreviacao_lista(f'{abrev}: "{subst}"')

            # self.Exibir_na_tabela_de_saida(abrev, subst)

            self.tabelaInfo.value += f'{abrev}: {subst}\n'
            self.update()

    def CriarAbreviacao(self, e):
        lin1 = Row(alignment='center')
        col1 = Column(tight=True)
        self.abrev = TextField(label='abrev', border_width=1, expand=True)
        self.subs = TextField(label='subs', border_width=1, expand=True)
        lin1.controls.append(self.abrev)
        lin1.controls.append(self.subs)
        col1.controls.append(lin1)
        # self.saida_dialog.value = ''
        # col1.controls.append(self.saida_dialog)
        def sv(e):
            self.Save_abreviation(e, 'abreviacoes.json')
        # salvar = ElevatedButton('Salvar',on_click=sv)
        # fechar =  ElevatedButton('Fechar',on_click=self.Sair)

        # col1.controls.append(Row([salvar, fechar], alignment='center'))
        # self.popoupM('Criar Atalho', col1)
        self.a = Poupup(title='Criar Atalho', funcao=sv, page = self.page, content = [col1])



    def Editar_atalhos(self,e):
        # self.controls = [self.tabelaInfo,self.abreviacao]
        class Edite_abrev(ft.ResponsiveRow):
            def __init__(self,  abrev = None, subs= None,func = None, num = None):
                # self.page = page
                super().__init__()
                self.func = func
                self.num = num
                def colun(x=1):
                    return {"xs":x,"sm": x, "md": x, "lg": x, "xl": x,"xxl": x}
       
                self.abrev = TextField(value = abrev, label='abrev', border_width=1,  col = colun(2), dense=True, content_padding=8,multiline = True)
                self.subs = TextField(value = subs, label='subs', border_width=1,  col = colun(8), dense=True, content_padding=8,multiline = True)
                self.savar = ft.IconButton(ft.icons.SAVE, col = colun(1), data = ['save',0], on_click=self.Delete1)
                self.delete = ft.IconButton(ft.icons.AUTO_DELETE, col = colun(1), data = ['delete', self.num], on_click=self.Save1)
                self.controls = [self.abrev, self.subs,self.savar,self.delete]

            def Delete1(self, e):
                self.func(e)

            def Save1(self, e):
                self.func(e)
        self.arq_abrev = Ler_json('abreviacoes.json')

        def Func(e):
            num = e.control.data[1]
            match e.control.data[0]:
                case 'delete':
                    def de(e):
                        abrev = self.controls[num].abrev.value
                        del self.arq_abrev[abrev]
                        del self.controls[num]
                        self.page.update()

                    c = Poupup('Confimar Exclusão?', de, self.page )

                case 'save':
                    abrev = self.controls[num].abrev.value
                    subs = self.controls[num].subs.value
                    self.arq_abrev[abrev] = subs
                    Escrever_json(self.arq_abrev, 'abreviacoes.json')
                    Poupup('Salvo!', page = self.page)


               

        l = []
        num = 0
        for i, j in self.arq_abrev.items():
            l.append(Edite_abrev(i, j, Func, num))
            num+=1

        def sav2(e):
            d = {}
            a = ''
            for i in self.controls[:-1]:
                d[i.abrev.value] = i.subs.value
                a += f'{i.abrev.value}: {i.subs.value} \n\n'

            self.arq_abrev = d

                  

            self.tabelaInfo = Text(a, width=800, selectable=True, size = 18)            
            Escrever_json(self.arq_abrev, 'abreviacoes.json')
            self.controls = [self.tabelaInfo,ft.Row([self.abreviacao, self.Editar])]
            self.page.update()
        def sair(e):
            self.controls = [self.tabelaInfo,ft.Row([self.abreviacao, self.Editar])]
            self.page.update()            


        self.controls = l+[ft.Row([ft.ElevatedButton('Salvar', on_click=sav2),ft.ElevatedButton('Sair', on_click=sair)])]
        self.page.update()


    def Clic(self):
        # Obtém o estado atual do Caps Lock
        caps_lock_state = kb.is_pressed('caps lock')

        # Inverte o estado do Caps Lock
        kb.press_and_release('caps lock')

        # Restaura o estado anterior do Caps Lock
        if caps_lock_state:
            kb.press('caps lock')
        else:
            kb.release('caps lock')

        # Clique do mouse (pode ser ajustado conforme necessário)
        click()
class Saida(ft.Column):
    def __init__(self):
        super().__init__()
        self.saidad = ft.Text('', selectable=True)
        self.controls.append(ft.Container(ft.ListView([self.saidad],auto_scroll = True, height=150,  ),bgcolor='white,0.03' ))
    def pprint(self, *texto):
        for i in list(texto):
            self.saidad.value += f'{i}\n'  
        self.page.update()
class Poupup:
    def __init__(self, 
                 title = None, 
                 funcao = None,
                 page = None,
                 texto =None,
                 nomes_botoes = ['Sim', 'Não'],
                content = None
                 ):
        super().__init__()
        self.page = page
        self.title = title
        self._content = content
        self._funcao = funcao
        self._texto = texto
        self.dialogo1 = ft.CupertinoAlertDialog(
            modal=False,
            open = True,
            title=ft.Row([ft.Text(self.title)],alignment='center'),

            # actions_alignment=ft.MainAxisAlignment.CENTER,
        )
        if self._content != None:
            if isinstance(self._content, list):
                self.dialogo1.content = ft.Column([ft.Text(self._texto)])
                self.dialogo1.content.controls += [i for i in self._content]

            else:
                self.dialogo1.content = ft.Column([ft.Text(self._texto)])
                self.dialogo1.content.controls += [self._content]  
        


        
        if self._funcao != None:
            self.dialogo1.modal=True

            self.dialogo1.actions = [
                ft.CupertinoDialogAction(
                nomes_botoes[0],
                text_style=ft.TextStyle(italic=True),
                is_destructive_action=True,
                on_click=self.yes_click
            ),
                ft.CupertinoDialogAction(text=nomes_botoes[1], is_default_action=False, on_click=self.no_click),

            ]


        self.page.dialog = self.dialogo1
        self.page.update()

    @property
    def content(self):
        return self._content
    @content.setter
    def content(self, valor):
        self._content = valor
        if self._content != None and isinstance(self._content, list):
            self.dialogo1.content = ft.Column([ft.Text(self._texto)])
            self.dialogo1.content.controls += [i for i in self._content]
        elif isinstance(self._content, str) | isinstance(self._content, int):
            self.dialogo1.content.controls[0].value = self._texto
        
        self.dialogo1.update() 



    @property
    def texto(self):
        return self._texto
    @texto.setter
    def texto(self, valor):
        self._texto = valor
        if isinstance(self._content, str) | isinstance(self._content, int):
            self.dialogo1.content.controls[0].value = self._texto        
            self.dialogo1.update() 
        

        

    @property
    def funcao(self):
        return self._funcao
    @funcao.setter
    def funcao(self, valor):
        self._funcao = valor
        if self._funcao != None:
            self.dialogo1.modal=True
            self.dialogo1.actions = [
                ft.CupertinoDialogAction(
                'Sim',
                text_style=ft.TextStyle(italic=True),
                is_destructive_action=True,
                on_click=self.yes_click
            ),
                ft.CupertinoDialogAction(text='Não', is_default_action=False, on_click=self.no_click),

            ]
        self.dialogo1.update() 





    def yes_click(self,e):
        if self._funcao != None:
            self._funcao(e)
        sleep(1)
        self.dialogo1.open = False
        self.page.update()


    def no_click(self,e):
        self.dialogo1.open = False
        self.page.update()
    

    def print_in_dialog(self, texto):
        # self.saida_dialog.value = texto
        # self.dialogo1.Content.update()
        self.dialogo1.content.controls[0].value = texto
        self.dialogo1.update() 
    


    def Escrever_json(self, nomedodicionario, nomedoarquivo):
        if nomedoarquivo[-4:] != 'json':
            nomedoarquivo = nomedoarquivo+'.json'
        with open(nomedoarquivo, 'w') as f2:
            json.dump(nomedodicionario, f2, indent=4)

    def Ler_json(self, nomedoarquivo):  # retorna um dicionário
        if nomedoarquivo[-4:] != 'json':
            nomedoarquivo = nomedoarquivo+'.json'
        with open(nomedoarquivo, 'r') as f2:
            try:
                a = json.load(f2)
                return a
            except json.JSONDecodeError as e:
                print(f'Erro ao decodificar JSON: {e}')
                return {}
class Content_dialog(ft.Column):
    def __init__(self, nome_do_json,page):
        super().__init__()
        self.page = page
        self.nome_do_json = nome_do_json
        self.tecla = None
        self.page.on_keyboard_event = self.Teclas
        
        self.dic = self.Ler_json(nome_do_json)
        self.horizontal_alignment='center'
        self.tight=True
        self.controls = [ft.Text()]
        self.pasta = SaveSelectFile2('path', 'pasta dos mandados')
        for i in self.dic.keys():
            if i == 'pasta_mandados':
                self.controls.append(self.pasta)
            else:  
                self.controls.append(ft.Row([ft.Text(i), ft.OutlinedButton(
                'config', on_click=self.Config_pontos_tela, data=i)]))

    def print_in_dialog(self, texto):
        self.controls[0].value = texto
        self.update()

    def Config_pontos_tela(self, e):
        ponto = e.control.data
        self.print_in_dialog(
            f'leve o mouse até "{ponto}" e pressione "enter".')
        while self.tecla != 'enter':
            sleep(0.3)
        self.tecla = None
        self.print_in_dialog(f'Ponto capturado')

        self.dic[ponto] = position() 



    def Teclas(self, e: ft.KeyboardEvent):
        match e.key:
            case 'Enter':
                self.tecla = 'enter'
            case 'Escape':
                self.tecla = 'esc'
        self.page.update()
        

    def Savar_pontos(self, e):
        if self.pasta.value not in ['', None]:
            self.dic['pasta_mandados'] = self.pasta.value 

        self.Escrever_json(self.dic, self.nome_do_json)
        self.print_in_dialog('Pontos salvos com sucesso')


    def Escrever_json(self, nomedodicionario, nomedoarquivo):
        if nomedoarquivo[-4:] != 'json':
            nomedoarquivo = nomedoarquivo+'.json'
        with open(nomedoarquivo, 'w') as f2:
            json.dump(nomedodicionario, f2, indent=4)


    def Ler_json(self, nomedoarquivo):  # retorna um dicionário
        if nomedoarquivo[-4:] != 'json':
            nomedoarquivo = nomedoarquivo+'.json'
        with open(nomedoarquivo, 'r') as f2:
            try:
                a = json.load(f2)
                return a
            except json.JSONDecodeError as e:
                print(f"Erro ao decodificar JSON: {e}")
                return {}
class SaveSelectFile2(ft.Row):
    def __init__(self, tipo, nome = None):
        '''
        tipo  == path: seleciona uma pasta (retorna o caminho completo da pasta selecionada)
        tipo  == file: seleciona um arquivo (retorna o caminho completo do arquivo selecionado)
        tipo  == save: sala um arquivo (retorna o caminho completo do arquivo, junto com seu nome)
        
        '''
        super().__init__()
        self.nome = nome
        self.pick_files_dialog = ft.FilePicker(on_result=self.pick_files_result)
        self.tamanho_texto = 500
        self.selected_files = ft.Text(width=self.tamanho_texto, selectable=True, max_lines = 1)
        self._value = self.selected_files.value
        self.tipo = tipo

        def Selecionar_arquivo(_):
            self.pick_files_dialog.pick_files(allow_multiple=True)

        def Selecionar_pasta(_):
            self.pick_files_dialog.get_directory_path(dialog_title = 'askdjahs', initial_directory = r'D:\baixados\programas_python\TabelaMandado\baixaryoutube\baixar_do_youtube\build\web')

        def Save1(_):
            self.pick_files_dialog.save_file()            



        if tipo == 'file':
            if self.nome == None:
                self.nome = 'Selecione o arquivo'            
            self.controls = [
                ft.ElevatedButton(
                    self.nome,
                    icon=ft.icons.UPLOAD_FILE,
                    on_click=Selecionar_arquivo,
                ),
                self.selected_files,
            ]
        elif tipo == 'path':
            if self.nome == None:
                self.nome = 'Selecione a pasta'
            self.controls = [
                ft.ElevatedButton(
                    self.nome,
                    icon=ft.icons.FOLDER,
                    on_click=Selecionar_pasta,
                ),
                self.selected_files,
            ]   
        elif tipo == 'save':
            if self.nome == None:
                self.nome = 'Digite o nome do arquivo'            
            self.controls = [
                ft.ElevatedButton(
                    self.nome,
                    icon=ft.icons.SAVE,
                    on_click=Save1,
                ),
                self.selected_files,

            ]                      

    def pick_files_result(self, e: ft.FilePickerResultEvent):
        if self.tipo == 'file':
            self.selected_files.value = (
                ",".join(map(lambda f: f.path, e.files)) if e.files else "Cancelled!"
            )
        elif self.tipo == 'path':
            self.selected_files.value = e.path if e.path else "Cancelled!"

        elif self.tipo == 'save':
            self.selected_files.value = e.path if e.path else "Cancelled!"            
            

        self.selected_files.update()
        self._value = self.selected_files.value


    # happens when example is added to the page (when user chooses the FilePicker control from the grid)
    def did_mount(self):
        self.page.overlay.append(self.pick_files_dialog)
        self.page.update()

    # happens when example is removed from the page (when user chooses different control group on the navigation rail)
    def will_unmount(self):
        self.page.overlay.remove(self.pick_files_dialog)
        self.page.update()

    @property
    def value(self):
        return self._value
    @value.setter
    def value(self, valor):
        self._value = valor
        self.selected_files.value = valor
        # self.selected_files.update()
class PopupMenu(UserControl):
    def __init__(self, 
                 nome_ou_icone = None, 
                 lista_de_controles = None,
                 tooltip = None,
                 col = None,
            ):
        super().__init__()
        self.nome_ou_icone = nome_ou_icone
        self.tooltip = tooltip
        self._colu = col
        self.p = PopupMenuButton(tooltip = self.tooltip, col = self._colu)
        self.lista_de_controles = lista_de_controles
        self._Add_itens()

    @property
    def coluna(self):
        return self._colu
    
    @coluna.setter
    def coluna(self, valor):
        self._colu = valor
        # self.p.col = valor
        

    def _Add_itens(self):
        if isinstance(self.lista_de_controles, list) and len(self.lista_de_controles) > 0:
            self.p.items = [PopupMenuItem(content = i) for i in self.lista_de_controles]
        else:
            print('Não há itens para adicionar')

    def Add_item(self, *controle):
        for i in list(controle):
            self.p.items.append(PopupMenuItem(content = i,))
        # self.p.update()

    def build(self):
        if self.nome_ou_icone != None and (isinstance(self.nome_ou_icone, Icon) or isinstance(self.nome_ou_icone, Text)):
            self.p.content = self.nome_ou_icone
        return self.p
class ItensPoup: #classe para criar controles para a classe PopupMenu2
    def __init__(self,
                 
        icon = None,
        text = None,
        on_click = None ,
        data = None,
        cor = None,
              
                 
        ):
        self.icon = icon
        self.quebra_linha(text, largura=30)
        self.on_click = on_click
        self.data = data
        self.cor = cor

    @property
    def text(self):
        return self._text

    @text.setter
    def text(self, texto):
        self.quebra_linha(texto, largura=30)

    def quebra_linha(self, texto, largura=36):
        palavras = texto.split()
        linhas = []
        linha_atual = ''
        
        for palavra in palavras:
            if len(linha_atual) + len(palavra) <= largura:
                linha_atual += palavra + ' '
            else:
                linhas.append(linha_atual.strip())
                linha_atual = palavra + ' '
        
        if linha_atual:
            linhas.append(linha_atual.strip())
        
        self._text  = '\n'.join(linhas)
class PopupMenu2(UserControl):
    def __init__(self, 
                 nome_ou_icone = None, 
                 controles:ItensPoup = None, #[icone, nome, on_click, data]
                 tooltip = None,
                 col = None,
            ):
        super().__init__()
        self.nome_ou_icone = nome_ou_icone
        self.tooltip = tooltip
        self._colu = col
        self.p = PopupMenuButton(tooltip = self.tooltip)
        self.lista_de_controles = controles
        self._Add_itens()

    @property
    def coluna(self):
        return self._colu
    
    @coluna.setter
    def coluna(self, valor):
        self._colu = valor
        # self.p.col = valor
        

    def _Add_itens(self):
        if isinstance(self.lista_de_controles, list) and len(self.lista_de_controles) > 0:
            self.p.items = [PopupMenuItem(icon = i.icon, text = i.text, on_click = i.on_click, data = i.data) for i in self.lista_de_controles]
        else:
            print('Não há itens para adicionar')

    def Add_item(self, *controle):
        
        for i in list(controle):
            if isinstance(i,ItensPoup ):
            # try:
            #     icon = i[0] 
            # except:
            #     icon = None
            # try:
            #     text = i[1] 
            # except:
            #     text = None
            # try:
            #     on_click = i[2] 
            # except:
            #     on_click = None
            # try:
            #     data = i[3]
            # except:  
            #     data = None
            
                self.p.items.append(PopupMenuItem(icon = i.icon, text = i.text, on_click = i.on_click, data = i.data))
        # self.p.update()

    def Add_item_control(self, *controle):        
        for i in list(controle):
            if isinstance(i,ItensPoup ):
                icone = Icon(i.icon, color = i.cor)
                texto = Text(i.text,color = i.cor)
                if i.icon == None:
                    icone.visible = False
                if i.text == None:
                    texto.visible = False
                conteudo = Row([icone,texto])
                if i.text == None and i.icon == None:
                    conteudo = None
                self.p.items.append(PopupMenuItem(content = conteudo, on_click=i.on_click))


    def Add_item_geral(self, *controle):        
        for i in list(controle):
            if isinstance(i,PopupMenuItem):
                self.p.items.append(i)


    def build(self):
        if self.nome_ou_icone != None and (isinstance(self.nome_ou_icone, Icon) or isinstance(self.nome_ou_icone, Text)):
            self.p.content = self.nome_ou_icone
        return self.p
class Tabs_new(UserControl):
    def __init__(self,
        data = None,
        on_change = None,
        tabs:list['nome',Control] = None,
        width=200,
        height=200,
        
                 
    ):
        super().__init__()
        self.data = data
        self.on_change = on_change
        self.w = width
        self.h = height
        self.tabs = tabs
        self.Construir_tabs()
        self.t = Tabs(
            selected_index=0,
            animation_duration=0,
            # divider_color  = 'blue',
            tabs=self.tabs_construidas,
            width=self.w,
            height=self.h,
            data = self.data,
            on_change=self.Func,
            # expand=1,
            
            )
        # self.height2 = None
        # self.width = None

    def Func(self,e):
        if self.on_change is not None:  
            return self.on_change(self,e)
        
    def Construir_tabs(self):
        self.tabs_construidas =  [Tab(text=i[0],  content = i[1]) for i in self.tabs]

    def Add_tab(self, *tabs:['nome',Control]):
        self.tabs_construidas +=  [Tab(text=i[0],  content = i[1]) for i in tabs]
        # self.t.update()

    @property
    def get_height(self):
        return self.h 
    @get_height.setter
    def set_height(self, valor):
        self.h = valor
        self.t.height = valor
        # self.t.update()

    @property
    def get_width(self):
        return self.w 
    @get_width.setter
    def set_width(self, valor):
        self.w = valor
        self.t.width = valor
        # self.t.update()


    def build(self):
        return self.t
class Dialogo(UserControl):
    def __init__(self,

                 title: str = 'título da janela',
                 content: Control | None = None,
                 on_dismiss: None = None,
                 salvar=None,
                 nome_json=None
                 ):
        super().__init__()
        # self.page = page
        self.titulo = title
        self._content = content
        self.on_dismiss = on_dismiss
        self.salvar = salvar
        self.nome_json = nome_json
        self.dlg_modal = AlertDialog(
            modal=True,
            title=Text(self.titulo),
            content=self._content,
            actions=[
                TextButton("Salvar", on_click=self.Salvar),
                TextButton("Sair", on_click=self.close_dlg),
                # TextButton("No", on_click=self.close_dlg),
            ],
            actions_alignment=MainAxisAlignment.END,
            on_dismiss=self.on_dismiss,
        )

    def build(self):
        return self.dlg_modal

    def open_dlg_modal(self):
        # self.page.dialog = self.dlg_modal
        self.dlg_modal.open = True
        self.update()

    def att(self):
        # self._content = Text('casdada')
        self.dlg_modal.content = Text('casdada')
        self.update()

    def close_dlg(self, e):
        self.dlg_modal.open = False
        self.update()

    def Salvar(self, e):
        return self.salvar(e, self.nome_json)

    @property
    def Content(self):
        return self._content

    @Content.setter
    def Content(self, valor):
        self._content = valor
        self.dlg_modal.content = self._content
        self.update()

    @property
    def Titulo(self):
        return self.titulo

    @Titulo.setter
    def Titulo(self, valor):
        self.titulo = valor
        self.dlg_modal.title = Text(self.titulo)
        self.update()
class ShowDF(UserControl):
    def __init__(self,
                 df#DataFrame ou dicionário
                 ):
        super().__init__()
        self.df = df if type(df) != dict else DataFrame(df)
        self.d1 = DataTable(border = border.all(1,'white,0.9'),
                            heading_row_color = 'white,0.5',
                            heading_row_height = 80,
                            column_spacing = 15,
                            # heading_row_color=colors.BLACK12,
                            vertical_lines = border.all(20,'white'),
                            horizontal_margin = 0,
                            data_row_max_height = 70,
                            # data_row_min_height = 50,
                            divider_thickness = 0,
                            show_checkbox_column = True,
                            sort_column_index = 4,
                            sort_ascending = True,
                            # data_row_color={"hovered": "0x30FF0000"},
                            )
        self.textsize = 15
        self.Colunas_tabela()
        self.Linhas_tabela()

    def Colunas_tabela(self):
        self.d1.columns = [DataColumn(Row([Text(width=10),Text(i,selectable = True,theme_style=TextThemeStyle.TITLE_MEDIUM)],alignment='center')) for i in list(self.df.columns)]
        
    
    def Linhas_tabela(self):
        linhas = []
        df_lista = self.df.values.tolist()
        for l,i in enumerate(df_lista):
            cell = [ DataCell(Row([Text(width=10),Text(j,text_align='center',selectable = True, size = self.textsize)],alignment='left',spacing = 3,)) for j in i]
            cor  = 'black' if l % 2 == 0 else 'white,0.01'
            linhas.append(DataRow(cells = cell, color = cor))
        self.d1.rows = linhas
            
    def build(self):
        return self.d1
class TabelaMandadosAcoes(ShowDF):
    def __init__(self, df, funcao):
        self.larguras()
        super().__init__(df)
        self.funcao = funcao

    def larguras(self):
        self.largura = {
            'Nº do Processo:':80, 
            'Nº do mandado:':80, 
            'Destinatario do mandado:':100,
            'Endereco':650, 
            'ação':60, 
            'Tipo do mandado:':80, 
            'Audiência':90,
            'Final de prazo':90, 
            'telefone':70
        }
   
    def Colunas_tabela(self):
        for j,i in enumerate(list(self.df.columns)):
            match i:
                case 'ação':
                    largura = 85 
                case _:
                    largura = 90
            linha = Row([
                Text(i, text_align='center', selectable=True, width=self.largura[i],color = 'black',weight = 'bold',
                     theme_style=TextThemeStyle.TITLE_MEDIUM, col={'xs': 12}),
                # Row([
                    IconButton(icons.ARROW_DROP_UP_SHARP, width=25,on_click = self.ordem,data = [i,True],
                               icon_color='black,0.8', col={'xs': 6}),
                    IconButton(icons.ARROW_DROP_DOWN_SHARP, width=25,on_click = self.ordem,data = [i,False],
                               icon_color='black,0.8', col={'xs': 6}),
                    Text(width=10)
                # ], alignment='left', tight=True,)
                # Text(width=15)
            ],
                # horizontal_alignment='center',
                # alignment="spaceEvenly",
                tight=True,
                spacing=0,
                height=200,
                run_spacing=0)
            self.d1.columns.append(DataColumn(linha, data=i))

        # self.d1.columns = [DataColumn() for i in list(self.df.columns)] + [DataColumn(Text('Enviar'))
        self.d1.columns.append(DataColumn(Text(' Enviar ',color = 'black',), data='Enviar'))
        self.d1.columns.append(DataColumn(Text(' PDF ',color = 'black',), data='PDF'))
        self.d1.columns.append(DataColumn(Text(' Add ',color = 'black',), data='Add'))
        self.d1.columns.append(DataColumn(Text(' Mand.\ndireto ',color = 'black',), data='Mand.D'))

    def Linhas_tabela(self):
        linhas = []
        df_lista = self.df.values.tolist()
        indx = list(self.df.index)

        nomes_colunas = ['Nº do Processo:', 'Nº do mandado:', 'Destinatario do mandado:',
                         'Endereco', 'ação', 'Tipo do mandado:', 'Audiência',
                         'Final de prazo', 'telefone']
        


        acao1 = ['aguardar', 'cancelar', 'consultar', 'devolver', 'email', 'enviado', 'imp_', 'impresso', 'ligar',
                 'Não encontrei', 'transferido', 'Transferir', 'voltar', 'zap']
        
        tipo1 = ['Afastamento',	'Avaliação',	'Busca',	'Citação',	'Citação e Intimação',	'Condução',	'Contramandado',
                 'Entrega',	'Imissão',	'Intimação',	'Intimação para Audiência',	'Notificação',	'Ofício',	'Penhora',	'Prisão',	'Reintegração']
        tipo1 = list(map(str.upper, tipo1))


        for l, i in enumerate(df_lista):
            cell = []

            for k, j, num_col in zip(list(self.df.columns), i, range(200)):

                if k in ['Destinatario do mandado:']:
                    cell.append(
                        DataCell(
                                    Row([
                                        Text(
                                                j, selectable=True,
                                                size=15,text_align = TextAlign.CENTER,
                                                weight = FontWeight.BOLD,
                                                width=self.largura[k]+100
                                            ),
                                        IconButton(icon = icons.SEARCH, scale = 1, icon_size = 13, data = [indx[l],'pesquisar',j], on_click=self.Func, tooltip = 'Pesquisar contato no zap')
                                    ], spacing=0, tight=True, run_spacing = 0),
                                    data = [indx[l],'copiado',j],
                                    on_double_tap = self.Func
                                )
                                
                        )
               
                elif k in ['Endereco']:
                    cell.append(DataCell(Text(j, selectable=True, size=12,text_align = TextAlign.START,
                                              width=self.largura[k]+100),
                                                data = [indx[l],'copiado',j],
                                                on_double_tap = self.Func                                              
                                              ))
                              
               
                elif k == 'ação':
                    match j:
                        case 'zap':
                            cor = 'green' 
                        case 'enviado':
                            cor = 'yellow,0.3'                         
                        case 'aguardar':
                            cor = 'blue,0.8'                        
                        case 'impresso':
                            cor = 'white,0.1'     
                        case 'devolver':
                            cor = 'red'
                        case 'imp_':
                            cor = 'blue'
                        case 'Transferir':
                            cor = 'white,0.5'                                                                                                                   
                        case _:
                            cor = 'black'                    
                    cell.append(DataCell(Container(Row([Drop_new(acao1, value=j,alinhamento = Alignment(-1, 0),
                                                       width_person=self.largura[k]+50,
                                                       on_change=self.Func2,
                                                       data=[indx[l],'acao2',[l,num_col]])],
                                             alignment='left'),bgcolor=cor)))
                
                
                elif k == 'Tipo do mandado:':
                    v = list(map(str.upper, [j])) if j not in [None,'', '--'] else ['--']
                    tipo2 = tipo1[:]
                    if v[0] not in tipo1:
                        tipo2.append(v[0])
                    cell.append(DataCell(Row([Drop_new(tipo2, value=v[0], width_person=self.largura[k]+50,alinhamento = Alignment(-1, 0),
                                                       on_change=self.Func2, data=[indx[l],'tipo2',[l,num_col]])], alignment='center')))
               
               
                elif k == 'telefone':
                    cell.append(DataCell(Row([Text(j, selectable=True, 
                                              )],alignment='center', expand=1, width=120),
                                                data = [indx[l],'copiado',j],
                                                on_double_tap = self.Func    
                                              ))
              
                elif k in ['Nº do Processo:']:
                    cell.append(DataCell(Row([Text(j, selectable=True, text_align='center',
                                              width=100)],alignment='center'),
                                            data = [indx[l],'copiado',j],
                                            on_double_tap = self.Func                                                
                                              ))

                elif k in ['Nº do mandado:']:
                    cell.append(DataCell(Row([Text(j, selectable=True, text_align='center',
                                              width=100),
                                        IconButton(icon = icons.PICTURE_AS_PDF, scale = 1, icon_size = 13, data = [indx[l],'ver_pdf',j], on_click=self.Func, tooltip = 'Visualizar PDF')

                                              
                                              ],alignment='center'),
                                            data = [indx[l],'copiado',j],
                                            on_double_tap = self.Func                                                
                                              ))                    
                




                elif k == 'Audiência':
                    try:
                        data_audiencia =  findall(r'(\d{2}/\d{2}/\d{4})', j)[0]
                    

                        current_time = datetime.now()
                        cor2  = None
                        # Função para converter string "dd/mm/yy" para datetime
                        def converter_para_datetime(data_string):
                            return datetime.strptime(data_string, '%d/%m/%Y')
                        if len(data_audiencia) > 5:
                            try:
                                data_convertida = converter_para_datetime(data_audiencia)
                            except:
                                print(j[:-9])
                                data_convertida = converter_para_datetime(j[:-9])

                            diferenca = data_convertida - current_time
                        

                            if diferenca.days < 8:
                                cor2  = 'red,0.5'
                            elif diferenca.days < 16:
                                cor2  = 'yellow,0.3'
                            else:
                                cor2  = None
                    except:
                        cor2  = None


                    cell.append(DataCell(Container(Row([Text(j, text_align='center', selectable=True,max_lines = 1, no_wrap = True)],alignment='center'),bgcolor=cor2),
                                            data = [indx[l],'copiado',j],
                                            on_double_tap = self.Func                                         
                                         ))
                
                elif k == 'Final de prazo':
                    try:
                        prazo = findall(r'(\d{2}/\d{2}/\d{4})', j)[0]
                        current_time = datetime.now()
                        cor2  = None
                        # Função para converter string "dd/mm/yy" para datetime
                        def converter_para_datetime(data_string):
                            return datetime.strptime(data_string, '%d/%m/%Y')
                        if len(prazo) > 5:
                            prazo_convertido = converter_para_datetime(prazo)

                            diferenca = prazo_convertido - current_time

                            if diferenca.days < 8:
                                cor2  = 'red,0.5'
                            elif diferenca.days < 16:
                                cor2  = 'yellow,0.3'
                            else:
                                cor2  = None
                    except:
                        cor2  = None


                    cell.append(DataCell(Container(Row([Text(j, text_align='center', selectable=True,max_lines = 1, no_wrap = True)],alignment='center'),bgcolor=cor2)))             
               
                else:
                    lagura = larg[k] if k in range(len(larg)) else 90
                    cell.append(DataCell(Row([Text(j, text_align='center', selectable=True,
                                              )],alignment='center')))

            cell.append(DataCell(Row([IconButton(icon=icons.SEND, 
                tooltip='Enviar Mandado', on_click=self.Func,
                data=[indx[l],'enviar'])])))
            
            cell.append(DataCell(Row([IconButton(icon=icons.PICTURE_AS_PDF_OUTLINED,
                tooltip='Enviar PDF', 
                on_click=self.Func, data=[indx[l],'pdf',[l]])])))
            
            cell.append(DataCell(Row([IconButton(icon=icons.PERM_CONTACT_CAL_ROUNDED,
                tooltip='Add Contato', 
                on_click=self.Func, data=[indx[l],'add'])])))     

            cell.append(DataCell(Row([IconButton(icon=icons.CANCEL_SCHEDULE_SEND_OUTLINED,
                tooltip='Enviar Mandado direto \npara o contato \naberto no zap', 
                on_click=self.Func, data=[indx[l],'Mand.D',[l]])])))                    

            cor = 'black' if l % 2 == 0 else 'white,0.05'
            linhas.append(DataRow(cells=cell, color=cor))
        self.d1.rows = linhas

    def FuncCopy(self, e):
        nome = e.control.data
        copy(nome)
        self.funcao(e)

    def Func(self, e):
        encontrou = False

        if e.control.data[1] in ['Mand.D','pdf']:
            for j,i in enumerate(list(self.df.columns)):
                if i == 'ação':
                    encontrou = True
                    break
            
            if encontrou:
                self.d1.rows[int(e.control.data[2][0])].cells[j].content.content.controls[0].getvalue = 'enviado'
                self.d1.rows[int(e.control.data[2][0])].cells[j].content.bgcolor = 'yellow,0.3'
                self.d1.update()




        self.funcao(e)

    def Func2(self, v, e):
        # print('mudar cor')
        match e.control.value:
            case 'zap':
                cor = 'green' 
            case 'enviado':
                cor = 'yellow,0.3'                         
            case 'aguardar':
                cor = 'blue,0.8'                        
            case 'impresso':
                cor = 'white,0.1'     
            case 'devolver':
                cor = 'red'
            case 'imp_':
                cor = 'blue'
            case 'Transferir':
                cor = 'white,0.5'                                                                                                                   
            case _:
                cor = 'black'        
        # print(cor)
        self.d1.rows[int(e.control.data[2][0])].cells[e.control.data[2][1]].content.bgcolor = cor
        # print(self.d1.rows[int(e.control.data[2][0])].cells[e.control.data[2][1]].content.bgcolor)
        self.d1.update()
        self.funcao(e)

    def duplo_clic(self, e):
        print('duplo clic')


    def ordem(self,e):
        coluna, ascendente  = e.control.data

        if coluna in ['Final de prazo', 'Audiência']:
            try:
                self.df[coluna] = to_datetime(self.df[coluna], format = "%d/%m/%Y %H:%M:%S", dayfirst = True)
            except:
                pass
            self.df = self.df.sort_values(by=coluna,ascending = ascendente)
            try:
                self.df[coluna] = self.df[coluna].dt.strftime("%d/%m/%Y %H:%M:%S")
            except:
                pass         
        else:
            self.df = self.df.sort_values(by=coluna,ascending = ascendente)
        self.Linhas_tabela()
        self.d1.update()
class TableCreate(UserControl):
    def __init__(self,borda: bool = False):
        super().__init__()
        self.borda = border.all(1,'white,0.3') if borda else None
        self.coluna = None
        self.linha = None
        self.d2 = DataTable(border = self.borda, heading_row_color = 'white,0.1')

    @property
    def Coluna(self):
        return self.coluna
    
    @Coluna.setter
    def Coluna(self,controle):
        self.d2.columns.append(DataColumn(controle))
        # self.update()

    @Coluna.setter
    def Colunas(self,list_controles):
        self.d2.columns = [DataColumn(i) for i in list_controles]
        # self.update()        
    
    @property
    def Linha(self):
        return self.linha

    @Linha.setter
    def Linha(self,linha):
        for i in enumerate(linha):
            cell = [ DataCell(j) for j in i]
        self.d2.rows.append(DataRow(cells = cell))
        # self.update() 

    @Linha.setter
    def linhas(self,list_linhas):
        linhas = []
        for l,i in enumerate(list_linhas):
            cell = [ DataCell(j) for j in i]
            cor  = 'black' if l % 2 == 0 else 'white,0.01'
            linhas.append(DataRow(cells = cell, color = cor))
        self.d2.rows = linhas
        # self.update()        

            
    def build(self):
        return self.d2
class ConfirmarSaida:
    def __init__(self,page, funcao=None):
        super().__init__()
        self.page = page
        self.funcao = funcao
        self.confirm_dialog = AlertDialog(
            modal=True,
            title=Text("Confirme!"),
            content=Text("Deseja realmente fechar o App?"),
            actions=[
                ElevatedButton("Sim", on_click=self.yes_click),
                OutlinedButton("Não", on_click=self.no_click),
            ],
            actions_alignment=MainAxisAlignment.END,
        )
        self.page.on_window_event = self.window_event
        self.page.window_prevent_close = True 
   


    def window_event(self, e):
            if e.data == "close":
                self.page.dialog = self.confirm_dialog
                
                self.confirm_dialog.open = True
                self.page.update()

    def yes_click(self,e):
        self.funcao
        self.page.window_destroy()

    def no_click(self,e):
        self.confirm_dialog.open = False
        self.page.update()
class Countdown(UserControl):
    def __init__(self, minutos, texto = ''):
        super().__init__()
        # self.page = Page
        self.minutos = minutos
        self.segundos = 60*minutos
        self.texto = texto
        self.pause = False

    def did_mount(self):
        self.running = True
        if self.minutos != '':            
            Thread(target=self.update_timer, daemon=True).start()

        else:
            self.countdown.value = self.texto
            self.update()

    def will_unmount(self):
        self.running = False

    def update_timer(self):
        while self.segundos and self.running:
            h, mins = divmod(self.segundos, 60*60)
            mins, secs = divmod(mins, 60)
            h, mins, secs = int(h), int(mins), int(secs)
            if self.texto != '':
                self.countdown.value = "{:s} {:02d}:{:02d}:{:02d}".format(self.texto,h, mins, secs)
            else:
                self.countdown.value = "{:02d}:{:02d}:{:02d}".format(h, mins, secs)

            self.update()
            sleep(1)
            self.segundos -= 1
            while self.pause:
                sleep(0.3)
          

    def build(self):
        self.countdown = Text()
        return self.countdown
'''
class Quadro(UserControl):
    def __init__(self, 
                content = None,
                #  page = Page,
                 width = None, 
                 height = None,
                 expand = 0,
                 bgcolor = None,
                 border_color = 'blue',
                 
                 ):
        super().__init__()
        # self.page = page
        self.content = content
        self.width = width
        self.height = height
        self.bgcolor = bgcolor
        self.border_color = border_color
        self.expand = expand
        self.bgcolor = bgcolor
    
    def build(self):
        return Container(
        content = self.content,
        border_radius=10,
        alignment=Alignment(0,0),
        border= border.all(0.2, color = self.border_color),
        width= self.width,
        height= self.height,
        expand = self.expand,
        bgcolor = self.bgcolor
        )
'''
class Contador(UserControl):
    def __init__(self, 
                 segundos = 10,
                 cor = 'green',
                 size = 20

    ):
        super().__init__()
        self.segundos = segundos
        self.cor = cor
        self.size = size
        self.saida = Row(visible=False)
        self.pause_contador = False
        self.parar_contador = False
    


    @property
    def Pause(self):
        return self.pause_contador
    
    @Pause.setter
    def Pause(self, valor: bool):
        self.pause_contador = valor
        self.update()

    @property
    def Parar(self):
        return self.parar_contador
    @Parar.setter
    def Parar(self, valor:bool):
        self.parar_contador = valor
        self.update()


    def did_mount(self):
        self.Cont()

    def build(self):
        return self.saida


    def Cont(self):
        self.saida.visible = True
        super().update()
        while self.segundos >= 0:
            horas2, minutos2, segundos2 = self.converter_segundos_para_horas_min_segundos(self.segundos)
            self.saida.controls = [Text(f"{horas2}:{minutos2}:{segundos2}", color  = self.cor, size = self.size)]
            super().update()
            self.segundos += -1
            sleep(1)
            while self.pause_contador:
                sleep(0.1)
            if self.parar_contador:
                self.saida.controls = [Text()]
                super().update()

                break
        # self.saida.controls = [Text()]
        self.saida.visible = False
        super().update()
        





    def converter_segundos_para_horas_min_segundos(self, segundos):
        def Algarismos(numero, qtd=2):
            numero = int(numero)
            return str(numero).zfill(qtd)
        horas = segundos // 3600  # 3600 segundos em uma hora
        horas = Algarismos(horas)
        segundos %= 3600
        minutos = segundos // 60  # 60 segundos em um minuto
        minutos = Algarismos(minutos)
        segundos %= 60
        segundos = Algarismos(segundos)

        return horas, minutos, segundos
class Quadro_assync(UserControl):
    def __init__(self, 
                content = None,
                 tipo = 'r', #ou 'c'
                #  page = Page,
                 width = None, 
                 height = None,
                 expand = 1,
                 bgcolor = None,
                 border_color = 'white',
                 
                 ):
        super().__init__()
        # self._page = page
        self.tipo = tipo
        self.content = content #Row(content) if self.tipo == 'r' else Column(content)
        self.width = width
        self.height = height
        self.bgcolor = bgcolor
        self.border_color = border_color
        self.expand = expand
        self.bgcolor = bgcolor
    
    def build(self):
        return Container(
        content = self.content,
        alignment=Alignment(0,0),
        border = border.all(1, color = self.border_color),
        width= self.width,
        height= self.height,
        expand = self.expand,
        bgcolor = self.bgcolor
        )
class Drop_new(UserControl):
    def __init__(self, 
        opitions = [], 
        value = None,
        width_person = None,
        on_change = None,
        data = None,
        cor  = None,
        alinhamento = Alignment(0, 0),
        label = None

                
                ):
        super().__init__()
        self.opitions  = opitions
        self.value = value
        self._width = 30 if opitions == [] else 80
        self.on_change = on_change
        self.data = data
        self.cor = cor
        self.alinhamento = alinhamento
        self._label = label

        if width_person != None:
            self._width = width_person         
 
        self._drop = Dropdown(        
                alignment= self.alinhamento,
                options=[dropdown.Option(i) for i in self.opitions],
                text_size = 15,
                border_width = 0,
                border=None,
                content_padding = 5,
                # border_color='white',
                expand=0,
                scale=1,
                autofocus = 0,
                value = self.value,
                width = self._width,
                # aspect_ratio = 1,
                height = 25,
                dense = True,
                text_style = TextStyle(weight = 'bold'),
                on_change=self.mudou,
                data  = self.data,
                bgcolor = self.cor,
                label = self._label,
                                                  
        ) 

    def build(self):  
        return self._drop
    
    def mudou(self, e):
        self.value = self._drop.value
        if self.on_change != None:
            self.enviar_change(e)
        self.update()

    def enviar_change(self,e):
        self.on_change(self, e)


    @property
    def getvalue(self):
        return self._drop.value
    @getvalue.setter
    def getvalue(self, valor):
        self._drop.options.append(dropdown.Option(valor))
        self._drop.value = valor
        super().update()
class New_task(UserControl):
    def __init__(self,
        task_delete,
        nome='',
        duracao=3,
        inicio=70,
        fim=170,
        passo = 1,
        ):
        super().__init__()
        self.task_delete = task_delete
        self.nome_tarefa = TextField(hint_text = 'nome da tarefa', width = 200, capitalization = TextCapitalization.CHARACTERS, value = nome, height=30, border_width = 0,dense=True)
        self.duracao_tarefa = Drop_new([0.1,0.3,0.5]+[i for i in range(1,31)], duracao, width_person = 70)
        self.inicio_tarefa = Drop_new([i for i in range(30,301)], inicio, width_person = 70)
        self.fim_tarefa = Drop_new([i for i in range(30,311)], fim, width_person = 70)
        self.passo_tarefa = Drop_new([0,0.1,0.3,0.5,0.7,0.9]+[i for i in range(1,20)], passo, width_person = 70)



    def build(self):
        remover_tarefa = IconButton(icon_color ='blue',icon=icons.DELETE, on_click = self.clicked, data ='del', icon_size = 18)
        self.play_parefa = IconButton(icon_color ='blue',icon=icons.PLAY_ARROW, on_click = self.clicked, data ='play tarefa', icon_size = 18)
        pause_parefa = IconButton(icon_color ='blue',icon=icons.PAUSE, on_click = self.clicked, data ='pause tarefa', icon_size = 18)

        linha_tarefa = [
            remover_tarefa,
            self.nome_tarefa,
            self.duracao_tarefa,
            self.inicio_tarefa,
            self.fim_tarefa,
            self.passo_tarefa,
            self.play_parefa,
            pause_parefa
        ]
        # linha_tarefa = Row([Container(i, height=40, border= border.all(0.1, color = 'blue')) for i in linha_tarefa], alignment='center', expand=1)
        linha_tarefa = Row([Container_new2(i, 10,30,1) for i in linha_tarefa], tight=True, spacing=0,alignment='center', expand=1)
        # linha_tarefa = Container(linha_tarefa, height = 50, border= border.all(0.3, color = 'blue'), border_radius=13)
        
        return Container_new2(linha_tarefa, 10)
        # return linha_tarefa
    
    def clicked(self, e):
        self.task_delete(self,e)
class Slider_new(UserControl):
    def __init__(self,
                texto = None,
                 min = None,
                 max = None,
                 divisions = None,
                 fator = 1, #valor a ser multiplicado por value
                 digitos = 1,
                 width = 200,
                 on_change = None,
                 data = None, 
                 value = False,
    ):



        super().__init__()
        self.texto = texto
        self.min = min
        self.max = max
        self.divisions = divisions
        self.fator = fator
        self.digitos = digitos
        self.width = width
        self.on_change = on_change
        self.data = data
        self.value = value

        self.passo_fim2 = Slider(active_color = '#004499',thumb_color = '#333333',min = self.min, 
                                 max = self.max, divisions=self.divisions,value = self.value, 
                                 width=self.width,on_change=self.mudou, data = self.data)
        valor = round(self.passo_fim2.value*self.fator,self.digitos)
        if self.digitos == 0:
            valor = int(valor)
        self.texto2 = Text(f'{self.texto} ({valor})')

    def mudou(self,e):
        valor = round(self.passo_fim2.value*self.fator,self.digitos)
        if self.digitos == 0:
            valor = int(valor)
        self.texto2.value = f'{self.texto} ({valor})'
        self.value = valor
        self.on_change(e, self)
        self.update()

    def build(self):
        return Row([self.texto2, self.passo_fim2],alignment='start', tight = True, spacing=0,run_spacing = 0, height=30 )

    @property
    def getvalue(self):
        return self.passo_fim2.value
    @getvalue.setter
    def setvalue(self, valor):
        self.passo_fim2.value = valor
        self.value = valor
        valor2 = round(self.passo_fim2.value*self.fator,self.digitos)
        if self.digitos == 0:
            valor2 = int(valor2)
        self.texto2.value = f'{self.texto} ({valor2})'
        self.update()
class Slider_new2(UserControl):
    def __init__(self,
                texto = None,
                 min = None,
                 max = None,
                 divisions = None,
                 fator = 1, #valor a ser multiplicado por value
                 digitos = 1,
                 width = None,
                 on_change = None,
                 data = None, 
                 value = False,
                 col1 = 4,
                
    ):



        super().__init__()
        self.texto = texto
        self.min = min
        self.max = max
        self.divisions = divisions
        self.fator = fator
        self.digitos = digitos
        self.width = width
        self.on_change = on_change
        self.data = data
        self.value = value
        self.col1 = col1
        # self.getvalue = None

        self.texto2 = Text(f'{self.texto}', no_wrap = True)
        self.passo_fim2 = Slider(min = self.min, active_color = '#004499',thumb_color = '#333333',
                                 max = self.max, value = self.value, 
                                on_change=self.mudou, data = self.data,  col = 12-self.col1)
        self.caixa = TextField(value = f'{self.passo_fim2.value:.0f}', border_width = 1, width=50,height=45, dense=True , content_padding = 5,
                               text_align = "center", on_change = self.mudou2,)
        


    def mudou(self,e):
        # self.texto2.value = f'{self.texto} ({self.passo_fim2.value:.0f})'
        if self.digitos == 0:
            self.passo_fim2.value = int(self.passo_fim2.value)
        else:
            self.passo_fim2.value = round(float(self.passo_fim2.value), self.digitos)

        self.caixa.value = f'{self.passo_fim2.value}'
        if self.on_change != None:
            self.on_change(e, self)
        self.value = self.passo_fim2.value
        self.update()
    def mudou2(self,e):
        # self.texto2.value = f'{self.texto} ({self.passo_fim2.value:.0f})'
        self.passo_fim2.value = self.caixa.value 
        self.value = self.passo_fim2.value
        if self.on_change != None:
            self.on_change(e, self)
        self.update()       

    def build(self):
        return ResponsiveRow([Row([self.texto2, self.caixa], col = self.col1),self.passo_fim2, ],expand = 0,alignment='start', spacing=0,run_spacing = 0, height=30,)#,alignment='start', tight = True, spacing=0,run_spacing = 0, height=30 

    @property
    def getvalue(self):
        return self.passo_fim2.value
    @getvalue.setter
    def getvalue(self, valor):
        self.passo_fim2.value = valor
        self.value = valor
        valor2 = round(self.passo_fim2.value,self.digitos)
        if self.digitos == 0:
            valor2 = int(valor2)
        self.caixa.value = f'{valor}'
        # self.texto2.value = f'{self.texto} ({valor2})'
        self.update()
class Saidas(UserControl):
    def __init__(self,
        texto1 = '',
        texto2 = '',
        texto3 = '',
        texto4 = '',
        texto5 = '',
        texto6 = '',  
        cor = 'white',
        size = 20,                              
                  ):
        super().__init__()
        # self.t1 = texto1
        # self.t2 = texto2
        # self.t3 = texto3
        # self.t4 = texto4
        # self.t5 = texto5
        # self.t6 = texto6
        self._texto1a = Text(texto1, color = cor, size = size, visible=False)
        self._texto2a = Text(texto2, color = cor, size = size, visible=False)
        self._texto3a = Text(texto3, color = cor, size = size, visible=False)
        self._texto4a = Text(texto4, color = cor, size = size, visible=False)
        self._texto5a = Text(texto5, color = cor, size = size, visible=False)
        self._texto6a = Text(texto6, color = cor, size = size, visible=False)
        self.Visibles(                
                 texto1,
                 texto2,
                 texto3,
                 texto4,
                 texto5,
                 texto6
                 )
      
    def build(self):
        self.saida = Row(
            alignment= MainAxisAlignment.START,
            vertical_alignment = 'center',
            
            # height=300,
            tight = True,
            wrap = True,
            expand=1,
            run_spacing = 2,
            # runs_count=1,
            # max_extent=300,
            # child_aspect_ratio=8,
            # spacing=1,
            # run_spacing=10,
            # padding = 0, 
            controls=[
                        self._texto1a, self._texto2a, self._texto3a,self._texto4a,self._texto5a,self._texto6a
                    #   Column([self._texto1a, self._texto2a, self._texto3a],alignment = MainAxisAlignment.START),
                    #   Column([self._texto4a,self._texto5a,self._texto6a],alignment = MainAxisAlignment.START),
                    #   Row([],alignment = MainAxisAlignment.SPACE_AROUND),  
                                     
                      ],                                            
        )
        # self.saida = Container(self.saida, margin=margin.all(6))
        
        return self.saida
    
    def Visibles(self,                 
                 texto1,
                 texto2,
                 texto3,
                 texto4,
                 texto5,
                 texto6
                 ):
        if texto1 != '':
            self._texto1a.visible = True
        if texto2 != '':
            self._texto2a.visible = True
        if texto3 != '':
            self._texto3a.visible = True
        if texto4 != '':
            self._texto4a.visible = True
        if texto5 != '':
            self._texto5a.visible = True
        if texto6 != '':
            self._texto6a.visible = True 
    
      
    @property
    def texto1(self):       
        return self._texto1a.value
    
    @texto1.setter
    def texto1(self, texto):
        self._texto1a.value = texto 
        self._texto1a.size = 20
        self._texto1a.visible = True 
        self._texto1a.no_wrap = True
  
    @texto1.setter
    def texto1_color(self, color):
        self._texto1a.color = color
    @texto1.setter
    def texto1_size(self, size):
        self._texto1a.size = size 
    
    @property
    def texto2(self):       
        return self._texto2a.value
    
    @texto2.setter
    def texto2(self, texto):
        self._texto2a.value = texto 
        self._texto2a.size = 20
        self._texto2a.visible = True 
        self._texto2a.no_wrap = True
  
    @texto2.setter
    def texto2_color(self, color):
        self._texto2a.color = color
    @texto2.setter
    def texto2_size(self, size):
        self._texto2a.size = size 
    
    @property
    def texto3(self):       
        return self._texto3a.value
    
    @texto3.setter
    def texto3(self, texto):
        self._texto3a.value = texto 
        self._texto3a.size = 20
        self._texto3a.visible = True 
        self._texto3a.no_wrap = True
  
    @texto3.setter
    def texto3_color(self, color):
        self._texto3a.color = color
    @texto3.setter
    def texto3_size(self, size):
        self._texto3a.size = size 
    
    @property
    def texto4(self):       
        return self._texto4a.value
    
    @texto4.setter
    def texto4(self, texto):
        self._texto4a.value = texto 
        self._texto4a.size = 20
        self._texto4a.visible = True 
        self._texto4a.no_wrap = True
  
    @texto4.setter
    def texto4_color(self, color):
        self._texto4a.color = color
    @texto4.setter
    def texto4_size(self, size):
        self._texto4a.size = size 
    
    @property
    def texto5(self):       
        return self._texto5a.value
    
    @texto5.setter
    def texto5(self, texto):
        self._texto5a.value = texto 
        self._texto5a.size = 20
        self._texto5a.visible = True 
        self._texto5a.no_wrap = True
  
    @texto5.setter
    def texto5_color(self, color):
        self._texto5a.color = color
    @texto5.setter
    def texto5_size(self, size):
        self._texto5a.size = size 
    
    @property
    def texto6(self):       
        return self._texto6a.value
    
    @texto6.setter
    def texto6(self, texto):
        self._texto6a.value = texto 
        self._texto6a.size = 20
        self._texto6a.visible = True 
        self._texto6a.no_wrap = True
  
    @texto6.setter
    def texto6_color(self, color):
        self._texto6a.color = color
    @texto6.setter
    def texto6_size(self, size):
        self._texto6a.size = size 

class Saidas2(UserControl):
    def __init__(self, 
                 texto1 = '',
                 texto2 = '',
                 texto3 = '',
                 texto4 = '',
                 texto5 = '',
                 texto6 = ''
                 ):
        super().__init__()

        self.texto1 = Text(texto1, size = 20, visible=False)
        self.texto2 = Text(texto1, size = 20, visible=False)
        self.texto3 = Text(texto1, size = 20, visible=False)
        self.texto4 = Text(texto1, size = 20, visible=False)
        self.texto5 = Text(texto1, size = 20, visible=False)
        self.texto6 = Text(texto1, size = 20, visible=False)
        self.Visibles(                
                 texto1,
                 texto2,
                 texto3,
                 texto4,
                 texto5,
                 texto6
                 )
    def build(self):
        self.saida = Row(
            alignment= MainAxisAlignment.START,
            vertical_alignment = 'center',
            
            # height=300,
            tight = True,
            wrap = True,
            expand=1,
            run_spacing = 2,
            # runs_count=1,
            # max_extent=300,
            # child_aspect_ratio=8,
            # spacing=1,
            # run_spacing=10,
            # padding = 0, 
            controls=[
                      self.texto1,self.texto2,self.texto6o3,
                      self.texto4,self.texto5,self.texto6
                    #   Row([],alignment = MainAxisAlignment.SPACE_AROUND),  
                                     
                      ],                                            
        )
        # self.saida = Container(self.saida, margin=margin.all(6))
        
        return self.saida

    def Visibles(self,                 
                 texto1 ,
                 texto2,
                 texto6o3,
                 texto6o4,
                 texto6o5,
                 texto6
                 ):
        if texto1 != '':
            self.texto1.visible = True
        if texto2 != '':
            self.texto2.visible = True
        if texto6o3 != '':
            self.texto3.visible = True
        if texto6o4 != '':
            self.texto4.visible = True
        if texto6o5 != '':
            self.exto5.visible = True
        if texto6 != '':
            self.texto6.visible = True                                                            



    '''
class Pomodoro(UserControl):
    def __init__(self):
        super().__init__()
        self.pomodoro_control_thread = True
        self.tempo_pomodoro_set = 0.1
        self.Metro_normal = Metronomo()
        self.Metro_normal.pause = False
        self.parar = False
        self.tempo_descanso_value = 6
        self.quado_saida = Row()
        self.saida_respiro = Column(visible=False)



    def did_mount(self):
        self.Pomodoro()

    def build(self):
        return  Row([self.quado_saida, self.saida_respiro])  
    def Pomodoro(self):
        texto = 'Pomodoro inciado...'
        self.quado_saida.visible = True        
        self.quado_saida.controls = [Text(texto)]
        super().update()

        while self.pomodoro_control_thread:
            self.quado_saida.visible = True
            
            segundos = self.tempo_pomodoro_set*60
            while segundos >= 0:
                h, mins = divmod(segundos, 60*60)
                mins, secs = divmod(mins, 60)
                h, mins, secs = int(h), int(mins), int(secs)
                if texto != '':
                    contador = "{:s} {:02d}:{:02d}:{:02d}".format(texto,h, mins, secs)
                else:
                    contador = "{:02d}:{:02d}:{:02d}".format(h, mins, secs)

                self.quado_saida.controls = [Text(contador)]
                sleep(1)
                super().update()
                segundos -= 1
                while self.Metro_normal.pause:
                    sleep(0.3)
                if self.parar or not self.pomodoro_control_thread:
                    break

            if self.parar or not self.pomodoro_control_thread:
                self.quado_saida.visible = False
                self.quado_saida.controls = None
                break

            MessageBeep(MB_ICONHAND)

            self.Respiro()
            
            if not self.pomodoro_control_thread:
                break
            MessageBeep(MB_ICONHAND)

            if not self.pomodoro_control_thread:
                break
            texto = 'Volte a treinor por '

        self.quado_saida.controls =  None

    def Respiro(self):
        # self.Metro_normal.pause = True
        # estado_saida_treinamento = self.saida_treinamento.visible
        # estado_saida_quado = self.quado_saida.visible
        # self.saida_treinamento.visible = False
        self.quado_saida.visible = False
        self.saida_respiro.visible = True
        descan = int(self.tempo_descanso_value*60/19.4)
        # print(descan)
        # self.Metro_normal.pause = False
        self.parar = False
        width_max = 740
        respiro = Container(content=Text(),bgcolor= colors.YELLOW,width = 0, border_radius=40)
        def Inspire(d):
            # self.quado_saida.content = Text(f'INSPIRE ({d})')
            s = Saidas(f'INSPIRE ({d})', cor = colors.YELLOW, size = 50)
            # s.saida_tempo_de_treino.visible = True
            # self.saida.texto1_size = 50
            # self.saida.texto1_color= colors.YELLOW
            self.saida_respiro.controls = [Column([s, respiro])]
            # self.quado_saida.content.alignment= MainAxisAlignment.CENTER

        def Expire(d):
            s = Saidas(f'EXPIRE  ({d})', cor = colors.GREEN, size = 50)

            # s.saida_tempo_de_treino.visible = True
            # self.saida.texto1_size = 50
            # self.saida.texto1_color= colors.GREEN
            self.saida_respiro.controls = [Column([s, respiro])]
            # self.quado_saida.content.alignment= MainAxisAlignment.CENTER


        for d in range(descan,0,-1):
            a = time()
            Inspire(d)
            super().update()
            for i in range(0,width_max,6*2):
                respiro.width = i
                sleep(0.001)
                if self.parar:
                    break
                super().update()
            respiro.bgcolor = colors.GREEN
            Expire(d)
            super().update()
            if self.parar:
                break             
            for i in range(width_max,0,-1*2):
                respiro.width = i
                if self.parar:
                    break                    
                sleep(0.01567)
                super().update()
            respiro.bgcolor = colors.YELLOW
            b = time()-a
            print(b)

        # self.saida_treinamento.visible = estado_saida_treinamento
        # self.quado_saida.visible = estado_saida_quado
        # self.saida_respiro.controls = None
        self.saida_respiro.visible = False
        self.quado_saida.visible = True
        self.Metro_normal.pause = False
        respiro.width = 0
        super().update()
    '''

class SaveSelectFile(UserControl):
    def __init__(self, tipo = 'txt'):
        super().__init__()
        self.tipo = tipo
        self.pick_files_dialog = FilePicker(on_result=self.pick_files_result)
        self.nome_arquivo = None
        self.func = None

    def pick_files_result(self, e: FilePickerResultEvent):
        match self.func:
            case 'select':
                self.nome_arquivo = f'{e.files[0].path}'
            case 'save':
                self.nome_arquivo = f'{e.path}.{self.tipo}'
            case 'select_pasta':
                self.nome_arquivo = f'{e.path}'

        super().update()

        
    # @property
    def Save(self):
        self.func = 'save'
        self.pick_files_dialog.save_file(file_type = FilePickerFileType.CUSTOM, allowed_extensions = [self.tipo])
        while not self.nome_arquivo:
            sleep(0.3)
        self.update()
        return self.nome_arquivo
    
    def Select(self, tipo = None):
        self.nome_arquivo = None
        if tipo not in [None, '']:
            self.tipo = tipo
        self.func = 'select'
        self.pick_files_dialog.pick_files(file_type = FilePickerFileType.CUSTOM, allowed_extensions = [self.tipo])
        while self.nome_arquivo == None:
            sleep(0.3)
        self.update()
        return self.nome_arquivo  


    def Select_pasta(self):        
        self.func = 'select_pasta'
        self.pick_files_dialog.get_directory_path(dialog_title = 'selecione a pasta')
        while not self.nome_arquivo:
            sleep(0.3)
        self.update()
        return self.nome_arquivo            
    
    def build(self):
        return self.pick_files_dialog 
    
class Container_new3(UserControl):
    def __init__(self,
                 content = None, 
                 gradiente = ('black', 'white'),
                 height = None,
                 scale = 1,
                 border_radius = None,
                 rotação = 0.3,
                 ShadowColor = 'blue,0.6',
                 page = None,
                
        ):
        super().__init__()
        self.page = page
        self.content = content
        self.gradiente = gradiente
        self.height = height
        self.scale = scale
        self.border_radius = border_radius
        self.rot = rotação
        self.ShadowColor = ShadowColor

        self.horizontal = BorderSide(3, colors.with_opacity(0.4,'blue'))
        self.vertical = BorderSide(3, colors.with_opacity(0.9,'gray'))
        
        self.bor = Border(left=self.horizontal, top=self.horizontal, right=self.vertical, bottom=self.vertical)
        self.bor = border.all(5, colors.with_opacity(0.3,'red'))
    
        self.sombra =  BoxShadow(
            spread_radius=0,
            blur_radius=15,
            color=self.ShadowColor,
            offset=Offset(3, 3),
            blur_style=ShadowBlurStyle.NORMAL)  


        self.gradient =  gradient=LinearGradient(
            begin=Alignment(0, 1),
            end=Alignment(0, -1),
            
            colors=[
                self.gradiente[0],
                self.gradiente[0],
                self.gradiente[0],
                self.gradiente[0],
                self.gradiente[0],
                self.gradiente[1],
                        ],
            tile_mode=GradientTileMode.MIRROR,
            rotation=self.rot*3.14/180,
        )
        self.saida = Container(content=self.content,   
                         border=self.bor, 
                         shadow = self.sombra, 
                         scale = self.scale, 
                         height = self.height,
                         border_radius = self.border_radius,
                         gradient=self.gradient, 
                         padding = 0
                         )
    def build(self):
        return self.saida




def Container_new2(i, border_radius =20, height = None, scale = None, gradiente = ("black", "#777777")):
    horizontal = BorderSide(3, colors.with_opacity(0.4,'blue'))
    vertical = BorderSide(3, colors.with_opacity(0.9,'gray'))
    
    bor = Border(left=horizontal, top=horizontal, right=vertical, bottom=vertical)
    bor = border.all(5, colors.with_opacity(0.3,'red'))
    
    sombra =  BoxShadow(
        spread_radius=0,
        blur_radius=15,
        color=colors.with_opacity(0.6,'blue'),
        offset=Offset(3, 3),
        blur_style=ShadowBlurStyle.NORMAL)        
    gradiente =  gradient=LinearGradient(
        begin=Alignment(0, 1),
        end=Alignment(0, -1),
        
        colors=[
            gradiente[0],
            gradiente[0],
            gradiente[0],
            gradiente[0],
            gradiente[0],
            gradiente[1],
                    ],
        tile_mode=GradientTileMode.MIRROR,
        rotation=0*3.14/180,
    )
    return Container(content=i,   border=bor, shadow = sombra, scale = scale, height = height,border_radius = border_radius,gradient=gradiente, padding = 0)

def Botao( texto = None,  icon = None,size = 30,width = 80, height = 30,on_click = None, data = None, color  = 'blue', rot = 30, gradiente = ("black", "#777777")):   
    return Container_new2(TextButton(content = Text(texto, size=20, weight='bold', no_wrap=True, color=color), data = data,on_click=on_click, 
                                     width = width,height = height), gradiente = gradiente   )
def Botao2( texto = None,  icon = None,size = 30,width = 80, height = 50,on_click = None, data = None, color  = 'blue', rot = 30):
    bor2 = border.BorderSide(20, colors.with_opacity(1,color))
    bor = border.all(0, colors.with_opacity(0.3,'#995555')) 
    sombra =  BoxShadow(
        spread_radius=0,
        blur_radius=30,
        color=colors.with_opacity(0.6,color),
        offset=Offset(3, 3),
        blur_style=ShadowBlurStyle.NORMAL)
    gradiente =  gradient=LinearGradient(
        begin=Alignment(-1, -1),
        end=Alignment(-0.1, -0.1),
        
        colors=[
            "#777777",
            "#000000",
            "#000000",
                    ],
        tile_mode=GradientTileMode.MIRROR,
        rotation=rot*3.14/180,
    )


    if icon == None:
        conteudo = ElevatedButton(content = Text(texto, size=25, weight='bold', no_wrap=True, color=color),bgcolor = colors.with_opacity(0,'black'))
    else:
        conteudo = Icon(icon, color=color)
    return Container( 
        content= conteudo,
            # [
                # Text("1", color=colors.WHITE),
                # Text("2", color=colors.WHITE, right=0),
                # Text("3", color=colors.WHITE, right=0, bottom=0),
                # Text("4", color=colors.WHITE, left=0, bottom=0),
            # ]
        # ),
        # top = 5,
        alignment=Alignment(0, 0),
        bgcolor='green',
        width=width,
        height=height,
        # height=220,
        border_radius=15,
        on_click = on_click,
        shadow=sombra,
        gradient=gradiente,
        border= bor, 
        data = data,    
            

        )


def Slider_new3(texto,min = 10, max = 240, width=150 ):
    return Row([Row([Text(texto),Slider(min = min, max = max, width=width,active_color = '#004499',thumb_color = '#333333',)])],alignment='start', tight = True, spacing=0,run_spacing = 0, height=30 )

def main_test(page: Page):
    page.window_width = 1500
    page.window_height = 750


    t = Contador(3600, cor= 'blue', size = 15)
    # t.continuar_treinando = True
    def Parar(e):
        t.segundos = int(b.value)
    b = TextField( on_submit=Parar)

    def atualizar(e,slider):
        # Tempo_de_estudo = Slider_new2('Tempo de estudo', 10, 240,data = 'Tempo_de_estudo', width=200, value = 10, on_change = atualizar).bunda()
        print(slider)
        page.update()
   
    Tempo_de_estudo = Slider_new2('Tempo de estudo', 0, 5.0,data = 'Tempo_de_estudo', value = 4.3, on_change = atualizar, col1=2)
    # Tempo_de_estudo = Row([Text('asldjfshldkajl'),Slider(min = 10, max = 240, width=350)])
    # Tempo_de_estudo = Slider_new3('casa', 10,250,130)
    # Tempo_de_estudo = ResponsiveRow([
    # Column(col=6, controls=[Text("Column 1")]),
    # Column(col=6, controls=[Text("Column 2")])
    # ])
    largura  = Text()
    def page_resize(e):
        print("New page size:", page.window_width, page.window_height)
        print("New page size:", page.window_width, page.window_height)
        print("New page size:", page.window_width, page.window_height)
        largura.value = page.window_width
        sleep(5)
        page.update()


    page.on_resize = page_resize
    page.on_close = page_resize

    def aaa(e):
        pass
            
    conta = Container_new3(content = Text('casadas'), border_radius = 15, rotação=50, ShadowColor='blue,0.2')

    conta2 = TextButton('01', on_click=aaa)

    tab = Tabs_new(tabs = [['tab1',Column([Text('meu ovo')])], ['tab2',Column([Text('minha pica')])]])
    tab.set_height = 500
    tab.set_width = 400
    tab.Add_tab(('buceta',Container(Column([Row([Text('aoisdoaijsdoij')])]))),('tab1',Column([Text('meu ovo')])))
    
    page.add(tab)
    page.update()



if __name__ == '__main__':
    app(target=main_test)            
